﻿using System;
using System.Collections;
using System.Collections.Generic;

namespace bankProductAdvertising.Class
{
	public class Advertisement
	{
		private Dictionary<String, Customer> customerDetailMap;
		private Dictionary<String, Product> customerProductMap;
		private MessageHandler messageHandler;

		public Advertisement(UploadDetails details, MessageHandler messageHandler)
		{
			this.customerDetailMap = details.CustomerDetail;
			this.customerProductMap = details.ProductDetail;
			this.messageHandler = messageHandler;
		}

		public Advertisement()
		{
		}

		public void creditCardAdvertisement()
		{
			foreach (KeyValuePair<String, Customer> customer in this.customerDetailMap) {
				if (customer.Value.Products.Find((obj) => obj.Name == "CREDIT_CARD") != null && customer.Value.Products.Find((obj) => obj.Name == "PREMIUM_CARD") == null) {
					String message = "Hi Mr/Ms" + customer.Value.getFullName() + ", we are offering a new Premium Credit Card for you. Upgrade your card to Premium Card with lots of benefits.";
					messageHandler.sendMessage(message, customer.Value.PhoneNumber);
				}
			}
		}
	}
}
