﻿using System.IO;
using bankProductAdvertising.Class;
using Newtonsoft.Json.Linq;

namespace bankProductAdvertising
{
	class MainClass
	{
		public static void Main(string[] args)
		{
			JObject properties = JObject.Parse(File.ReadAllText(@"../../configuration.json"));
			MessageHandler messageHandler = new MessageHandler(properties.GetValue("appKey").ToString(), properties.GetValue("appSecret").ToString(), properties.GetValue("defaultOrigin").ToString());
			UploadDetails details = new UploadDetails();
			Advertisement ads = new Advertisement(details, messageHandler);
			ComplaintSystem complaints = new ComplaintSystem(details, messageHandler);

			ads.creditCardAdvertisement();//Send a message to all customers who have a Credit card but no a Premium card
			complaints.updateComplaints();//Send a message to all customers who have reached the complaint system.
		}
	}
}
